#include <stdio.h>

class Token;

struct Element
{
  Token *token;
  Element *next;
};

class Token
{
public:
  Token (int fd, char recurse);
  ~Token ();
  int Type ();
  char *String ();
  int Number ();
  Token *Array (int element);
  int ToHollerith (int fd);
  
private:
  int type;
  int number;
  char *string;
  struct Element *array;
};

enum
{
  TYPE_STRING,
  TYPE_NUMBER,
  TYPE_ARRAY
};
